<template>
  <el-col :span="16" :offset="6">
    <el-form label-width="100px" ref="formRef" :model="form">
      <el-form-item
        label="质检员"
        prop="qualityInspector"
        style="margin-bottom: 20px"
        :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }"
        v-if="taskDefinitionKey == 'QCLeaderApprove'"
      >
        <el-select
          v-model="form.qualityInspector"
          clearable
          style="width: 100%"
          :filterable="true"
        >
          <el-option
            v-for="item in userOptions"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item
        label="审批建议"
        prop="reason"
        style="margin-bottom: 20px"
        :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }"
      >
        <el-input
          type="textarea"
          v-model="form.reason"
          placeholder="请输入审批建议"
        />
      </el-form-item>
    </el-form>
    <div style="margin-left: 10%; margin-bottom: 20px; font-size: 14px">
      <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        @click="handleAudit(1)"
        v-if="
          !['storeManagerApprove'].includes(taskDefinitionKey) ||
          (['storeManagerApprove'].includes(taskDefinitionKey) &&
            [2].includes(+outInData.flowableStatus))
        "
        >通过
      </el-button>
      <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        :loading="isSaveLoading"
        @click="storeManagerApprove"
        v-if="
          ['storeManagerApprove'].includes(taskDefinitionKey) &&
          activeComp == 'inoutBound' &&
          ![1, 2].includes(+outInData.flowableStatus)
        "
        >申请入库
      </el-button>
      <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="
          !['starter', 'qualityInspectionFeedback', 'QCLeaderApprove'].includes(
            taskDefinitionKey
          ) && ![1, 2].includes(+outInData.flowableStatus)
        "
        >驳回
      </el-button>

      <el-dropdown
        @command="(command) => handleCommand(command)"
        style="margin-left: 30px"
      >
        <span class="el-dropdown-link"
          >更多<i class="el-icon-arrow-down el-icon--right"></i
        ></span>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item command="cancel">作废</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>

      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleBackList"
        >退回
      </el-button> -->
      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        >不通过
      </el-button>
      <el-button
        icon="el-icon-edit-outline"
        type="primary"
        size="mini"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        @click="handleUpdateAssignee"
        >转办
      </el-button> -->
      <ele-modal
        custom-class="ele-dialog-form long-dialog-form"
        :centered="true"
        v-if="visible"
        :visible.sync="visible"
        :title="title"
        :close-on-click-modal="false"
        width="80%"
        :modal="false"
        @close="cancel"
      >
      </ele-modal>
    </div>
  </el-col>
</template>

<script>
  import {
    UpdateReceiveInformation,
    getReceiveSaleOrderrecordDetail,
    cancel
  } from '@/api/bpm/components/purchasingManage/purchaseorderreceive';
  import { approveTaskWithVariables } from '@/api/bpm/task';
  import { getWarehouseListByIds } from '@/api/bpm/components/saleManage/saleorder';
  import {
    getOutInBySourceBizNo,
    uploadQualityFile
  } from '@/api/classifyManage';
  import { listAllUserBind } from '@/api/system/organization';
  import outin from '@/api/warehouseManagement/outin';

  // 流程实例的详情页，可用于审批
  export default {
    name: '',
    components: {},
    props: {
      businessId: {
        default: ''
      },
      taskId: {
        default: ''
      },
      id: {
        default: ''
      },
      id: {
        default: ''
      },
      taskDefinitionKey: {
        default: ''
      }
    },
    data() {
      return {
        isSaveLoading: false,
        form: {
          qualityInspector: '',
          reason: ''
        },
        outInData: {
          flowableStatus: ''
        },
        visible: false,
        userOptions: [],
        activeComp: ''
      };
    },
    async created() {
      this.userOptions = [];
      listAllUserBind().then((data) => {
        this.userOptions.push(...data);
      });
      if (this.taskDefinitionKey == 'storeManagerApprove') {
        let data = await getReceiveSaleOrderrecordDetail(this.businessId);
        try {
          this.outInData = await getOutInBySourceBizNo(data.receiveNo);
          console.log('outInData----------', this.outInData);
        } catch (error) {}
      }
    },
    mounted() {
      console.log('taskDefinitionKey-------------', this.taskDefinitionKey);
    },
    methods: {
      cancel() {
        this.visible = false;
      },
      async storeManagerApprove() {
        let res = await this.getTableValue();
        let storageData = res.returnStorageData;
        console.log(storageData);
        // 入库来源storageSource 0-正常  1-外部(外部跳过内部审核流程)
        storageData.storageSource = 1;
        try {
          this.isSaveLoading = true;
          await outin.save(storageData);
          approveTaskWithVariables({
            id: this.taskId,
            reason: this.form.reason,
            variables: {
              pass: true
            }
          }).then((res) => {
            if (res.code != '-1') {
              this.$emit('handleAudit', {
                status: 1,
                title: '入库'
              });
            }
            this.isSaveLoading = false;
          });
        } catch (error) {
          this.isSaveLoading = false;
          this.$message.error('保存失败');
        }
      },
      /** 处理转办审批人 */
      handleUpdateAssignee() {
        this.$emit('handleUpdateAssignee');
      },
      /** 退回 */
      handleBackList() {
        this.$emit('handleBackList');
      },
      activeCompChange(activeComp) {
        this.activeComp = activeComp;
      },
      async handleAudit(status) {
        let storemanIds = '';

        //发起人补充
        if (this.taskDefinitionKey === 'starter') {
          let arr = await this.getTableValue();
          if (!arr) {
            return;
          }
          let data = await UpdateReceiveInformation(arr);
          if (data.code != '0') {
            return;
          }
        }
        if (this.taskDefinitionKey === 'deptLeaderApprove') {
          let arr = await this.getTableValue();
          let ids = arr.form.productList.map((item) => item.warehouseId);
          let data = await getWarehouseListByIds(ids || []);
          storemanIds = data.map((item) => item.ownerId);
        }
        if (this.taskDefinitionKey === 'QCLeaderApprove' && status) {
          if (!this.form.qualityInspector) {
            return this.$message.error('请选择质检员！');
          }
        }
        if (this.taskDefinitionKey === 'qualityInspection' && status) {
          let arr = await this.getTableValue(); // 是否全部已检
          if (!arr.isAllChecked) {
            return this.$message.error('请完成质检！');
          }
        }
        if (this.taskDefinitionKey === 'qualityInspectionFeedback' && status) {
          let arr = await this.getTableValue();
          console.log('arr.qualityInspector', arr);
          // if (arr.qualityInspector.qualityFile.length == 0) {
          //   return this.$message.error('请上传回执附件！');
          // }
          console.log(arr);
          if (
            arr.qualityInspector.qualityFile &&
            arr.qualityInspector.qualityFile.length > 0
          ) {
            await uploadQualityFile(arr.qualityInspector);
          }
        }
        this._approveTaskWithVariables(
          status,
          storemanIds.length > 0
            ? Array.from(new Set(storemanIds)).toString()
            : ''
        );
      },
      async _approveTaskWithVariables(status, storemanIds) {
        let variables = {
          pass: !!status
        };
        if (storemanIds) {
          variables['storemanIds'] = storemanIds;
        }
        if (this.form.qualityInspector) {
          variables['qualityInspector'] = this.form.qualityInspector;
        }

        approveTaskWithVariables({
          id: this.taskId,
          reason: this.form.reason,
          variables
        }).then((res) => {
          if (res.data.code != '-1') {
            this.$emit('handleAudit', {
              status,
              title: status === 0 ? '驳回' : ''
            });
          }
        });
      },
      getTableValue() {
        return new Promise((resolve, reject) => {
          this.$emit('getTableValue', async (data) => {
            resolve(await data);
          });
        });
      },

      //更多
      handleCommand(command) {
        if (command === 'cancel') {
          this.$confirm('是否确认作废？', {
            type: 'warning',
            cancelButtonText: '取消',
            confirmButtonText: '确定'
          })
            .then(() => {
              cancel({
                id: this.taskId,
                reason: this.form.reason,
                businessId: this.businessId
              })
                .then(() => {
                  this.$emit('handleClose');
                })
                .catch(() => {
                  this.$message.error('流程作废失败');
                });
            })
            .catch(() => {});
        }
      }
    }
  };
</script>

<style lang="scss"></style>
